import processing.pdf.*;
import java.util.Calendar;
import java.util.List;

class DropNode {

  float x;
  float y;
  float r;
  
  float v = 1;
  
  float red = 30 + random(60);
  float green = 0;
  float blue = 0;
  
  int life = 1;
  boolean falling = true;
  
  DropNode(float x, float y, float r) {
    this.x = x;
    this.y = y;
    this.r = r;
    
    if (this.r < 6) {
      falling = true;
    }
    
    blue = cos(x)*sin(y)*50;
  }
  
    void tick() {
      y += v;
      v *= 1.04;
  }
  
  void draw() {
    fill(red, green, blue);
    stroke(red, green, blue);
    ellipse(x, y, r*2, r*2);
  }
  
}

boolean savePDF = false;

int maxCount = 5000; //max count of the cirlces
int currentCount = 1;
List<DropNode> dropNodes = new ArrayList<DropNode>();

void setup() {
  size(1000, 1000);
  smooth();
  frameRate(1000);

  // first circle
  //treeNodes.add(new TreeNode(width/2, height/2, 10));
  //r[0] = 400; 
}


void draw() {
  if (savePDF) beginRecord(PDF, timestamp()+".pdf");
  background(206, 225, 255);

  strokeWeight(0.5);
  //noFill();


  dropNodes.add(new DropNode(random(0, width), 0, 4));
  dropNodes.add(new DropNode(random(0, width), 0, 4));
  dropNodes.add(new DropNode(random(0, width), 0, 4));
  dropNodes.add(new DropNode(random(0, width), 0, 4));
  dropNodes.add(new DropNode(random(0, width), 0, 4));

  for (int i = 0; i < dropNodes.size(); ++i) {
    DropNode dp = dropNodes.get(i);
    float dx =dp.x - width/2;
    float dy =dp.y - height/2;
    println((dx*dx+dy*dy));
    if ((dx*dx+dy*dy) < 200*200) {
      //dp.y-=dp.v;
      dp.x += dp.x > width/2 ? 1 : -1;
    } else {
      dp.tick();
    }
    
    dp.draw();
  }

  //dropNodes.removeIf(dp -> dp.y > height);

  if (savePDF) {
    savePDF = false;
    endRecord();
  }
}

void keyReleased() {
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
  if (key == 'p' || key == 'P') savePDF = true;
}

// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}